static char *SccsId = "@(#)delay.c 1.2 () 10/19/94";

/*
/* The program 'delay' determines the delay time from 
/* a spice output
/*
/* author: A.J. van Genderen
*/

#include <stdio.h>

char *argv0 = "delay";

FILE *fp_out = stdout;
FILE *fp_in;

char *fn_in = NULL;

char str1[512];
char str2[512];

main (argc, argv)
int argc;
char *argv[];
{
    char *s;
    char buf[512];

    double t, tprev, t1, t2;
    double v1, v1prev, v2, v2prev;

    int match, end;

    char c;

    while (--argc > 0) {
        if ( (*++argv)[0] == '-' ) {
	    for (s = *argv + 1; *s != '\0'; s++) {
	        switch (*s) {
		    default: 
		        fprintf (stderr, 
				 "%s: illegal option: %c\n", argv0, *s);
		        die ();
	        }
	    }
	}
	else {
            if (fn_in == NULL) {
		fn_in = *argv;
	    }
	}
    }

    if (fn_in == NULL) {
	fprintf (stderr, "\nUsage: %s [options] infile\n\n", argv0);
	die ();
    }

    if ((fp_in = fopen (fn_in, "r")) == NULL) {
        fprintf (stderr, "Cannot open %s\n", fn_in);
        die ();
    }

    sprintf (str1, "");

    match = 0;
    while (!match && fscanf (fp_in, "%s", str2) == 1) {

        if (strcmp (str1, "Transient") == 0
            && strcmp (str2, "Analysis") == 0) {

	    while ((c = getc (fp_in)) != '\n' && c != EOF);
	    while ((c = getc (fp_in)) != '\n' && c != EOF);
	    if (fscanf (fp_in, "%s", buf) == 1 
		&& strcmp (buf, "Index") == 0) {
		while ((c = getc (fp_in)) != '\n' && c != EOF);
		while ((c = getc (fp_in)) != '\n' && c != EOF);
		match = 1;
	    }
        }

        strcpy (str1, str2);
    }

    if (match) {
	tprev = 0;
	v1prev = 0;
	v2prev = 0;

	t1 = -1;
	t2 = -1;

	end = 0;
	while (!end && fscanf (fp_in, "%*d %le %le %le", &t, &v1, &v2) > 0) {

	    if (v1prev <= 2.5 && v1 >= 2.5) {
		t1 = tprev + ((2.5 - v1prev) / (v1 - v1prev)) * (t - tprev);
	    }

	    if (v2prev <= 2.5 && v2 >= 2.5) {
		t2 = tprev + ((2.5 - v2prev) / (v2 - v2prev)) * (t - tprev);
	    }

	    tprev = t;
	    v1prev = v1;
	    v2prev = v2;

	    while ((c = getc (fp_in)) != '\n' && c != EOF);
	    while ((c = getc (fp_in)) == ' ' || c == '\t');
	    if (c < '0' || c > '9') {
		while ((c = getc (fp_in)) != '\n' && c != EOF);
		if (fscanf (fp_in, "%s", buf) == 1 
		    && strcmp (buf, "Index") == 0) {
		    /* new page */
		    while ((c = getc (fp_in)) != '\n' && c != EOF);
		    while ((c = getc (fp_in)) != '\n' && c != EOF);
		}
		else
		    end = 1;
	    }
	    else
		ungetc (c, fp_in);
	}

	if (t2 > t1 && t1 > 0 && t2 > 0) {
	    fprintf (fp_out, "%.5f\n", (t2 - t1) * 1e9);  /* in nsec */
	}
	else {
	    fprintf (fp_out, "-999\n");
	}
    }

    return (0);
}

die ()
{
    exit (1);
}
